#include <stdlib.mqh>
#include <stderror.mqh> 


//+<< Hourly Restrictions on Trade >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>+
extern string     HourlyRetrict_Parameters = "*** Hourly Restrictions ***";

extern bool       UseHourTrade      =  true;

//first time frame
extern bool       UseHourTrade1     =  true;

extern string     FromHour1         =  "23:00";  //from
extern string     UntilHour1        =  "01:00"; //Until
extern bool       EndInTomorrow1    =  true;         // Whether the end time is the next day, like you want to trade the period: 18:00~06:00, the 06:00 is the next am

//second time frame
extern bool       UseHourTrade2     =  true;   

extern string     FromHour2         =  "10:00";  //from
extern string     UntilHour2        =  "11:00"; //until
extern bool       EndInTomorrow2    =  false;         // Whether the end time is the next day, like you want to trade the period: 18:00~06:00, the 06:00 is the next am

//third time frame
extern bool       UseHourTrade3     =  true;   

extern string     FromHour3         =  "20:00";  //from
extern string     UntilHour3        =  "21:00"; //until
extern bool       EndInTomorrow3    =  false;         // Whether the end time is the next day, like you want to trade the period: 18:00~06:00, the 06:00 is the next am



// ------------------------------------------------------------------------------------------------
// START
// ------------------------------------------------------------------------------------------------
int start()
{ 
// MT4 Trade Time Filter
   if( UseHourTrade && (!FilterOnePlus() && !FilterTwoPlus() && !FilterThreePlus()))
   {
      return(0);
   }
}

bool FilterOnePlus()
{
   if(UseHourTrade) 
   {
      if (UseHourTrade1)
      {
         datetime time_now, time_begin, time_end, time_end_today;
         time_now = TimeCurrent();
         time_begin = StrToTime(FromHour1);
         if(!EndInTomorrow1) 
         {
            time_end = StrToTime(UntilHour1);
         }
         else if(EndInTomorrow1) 
         {
            time_end = StrToTime(UntilHour1) + 86400;
            time_end_today = StrToTime(UntilHour1);
         }
         if(!EndInTomorrow1 && (time_now<time_begin || time_now>time_end)) 
         {
            return(false);
         }
         else if(EndInTomorrow1 && time_now>time_end_today && time_now<time_begin) 
         {
            return(false);
         }
      }
   }
   return(true); 
}

bool FilterTwoPlus()
{
   if(UseHourTrade) 
   {
      if (UseHourTrade2)
      {
         datetime time_now, time_begin, time_end, time_end_today;
         time_now = TimeCurrent();
         time_begin = StrToTime(FromHour2);
         if(!EndInTomorrow2) 
         {
            time_end = StrToTime(UntilHour2);
         }
         else if(EndInTomorrow2) 
         {
            time_end = StrToTime(UntilHour2) + 86400;
            time_end_today = StrToTime(UntilHour2);
         }
         if(!EndInTomorrow2 && (time_now<time_begin || time_now>time_end)) 
         {
            return(false);
         }
         else if(EndInTomorrow2 && time_now>time_end_today && time_now<time_begin) 
         {
            return(false);
         }
      }
   }
   return(true); 
}

bool FilterThreePlus()
{
   if(UseHourTrade) 
   {
      if (UseHourTrade3)
      {
         datetime time_now, time_begin, time_end, time_end_today;
         time_now = TimeCurrent();
         time_begin = StrToTime(FromHour3);
         if(!EndInTomorrow3) 
         {
            time_end = StrToTime(UntilHour3);
         }
         else if(EndInTomorrow3) 
         {
            time_end = StrToTime(UntilHour3) + 86400;
            time_end_today = StrToTime(UntilHour3);
         }
         if(!EndInTomorrow3 && (time_now<time_begin || time_now>time_end)) 
         {
            return(false);
         }
         else if(EndInTomorrow3 && time_now>time_end_today && time_now<time_begin) 
         {
            return(false);
         }
      }
   }
   return(true); 
}